﻿using System;

namespace InstanceFactory.CustomPrivateAccessor.ConsoleApplication
{
  /// <summary>
  /// Implementation of a class with non-public members.
  /// </summary>
  public class ClassWithNonPublicMembers
  {
    #region Public Properties

    /// <summary>
    /// Gets / sets the value of a public property.
    /// </summary>
    public string PublicProperty { get; set; }

    #endregion Public Properties


    #region Protected Properties

    /// <summary>
    /// Gets / sets the value of a protected property.
    /// </summary>
    protected string ProtectedProperty { get; set; }

    #endregion Protected Properties


    #region Private Properties

    /// <summary>
    /// Gets / sets the value of a private property.
    /// </summary>
    private string PrivateProperty { get; set; }

    #endregion Private Properties


    #region Private Static Properties

    /// <summary>
    /// Gets / sets the value of a private static property.
    /// </summary>
    private static string PrivateStaticProperty { get; set; }

    #endregion Private Static Properties


    #region Protected Methods

    /// <summary>
    /// A simple protected method with a parameter.
    /// </summary>
    /// <param name="parameter">The parameter</param>
    /// <returns>Another string.</returns>
    protected string ProtectedMethod
      (
      string parameter
      )
    {
      Console.WriteLine("Parameter: >{0}<", parameter);

      return (parameter + " processed");
    }

    #endregion Protected Methods
  }
}
